<i18n src="./locales.json"></i18n>

<template>
  <div>
    <el-input
      :placeholder="`${$t('customer.input.filter')}...`"
      v-model="filter"
      size="medium"
      class="demo-input-suffix"
      clearable
    >
      <i slot="prefix" class="el-input__icon el-icon-search"></i>
      <i v-if="loading" slot="suffix" class="el-input__icon el-icon-loading"></i>
    </el-input>

    <div style="margin-bottom: 5px;" /> 

    <el-table v-loading="loading" :data="customers" stripe border style="width: 100%">
      <el-table-column width="70" align="center">
        <template slot-scope="scope">
          <el-button
            slot="reference"
            type="primary"
            icon="el-icon-edit"
            circle
            @click="onEditCustomer(scope.row)"
          ></el-button>
        </template>
      </el-table-column>
      <el-table-column prop="fullName" label="Nombre" width="180" sortable></el-table-column>
      <el-table-column prop="email" label="Correo" width="180" sortable></el-table-column>
      <el-table-column
        prop="creationDate"
        label="Fecha Creación"
        width="auto"
      ></el-table-column>
      <el-table-column width="70" align="center">
        <template slot-scope="scope">
          <el-popconfirm
            placement="left"
            confirmButtonText="Si"
            cancelButtonText="No"
            icon="el-icon-info"
            iconColor="red"
            :title="`Eliminar ${scope.row.fullName}?`"
            @onConfirm="deleteCustomer(scope.row)"
          >
            <el-button circle slot="reference" type="danger" icon="el-icon-delete"></el-button>
          </el-popconfirm>
        </template>
      </el-table-column>
    </el-table>

    <el-dialog title="Editar cliente" width="50%" :visible.sync="dialogCustomer" center>
      <div v-if="!!selectedCustomer">
        <customerForm
          input-size="small"
          :init-customer="selectedCustomer"
          submit-label="Editar"
          cancel-label="Cancelar"
          @submit="editCustomer"
          @cancel="dialogCustomer = false"
        />
      </div>
    </el-dialog>
  </div>
</template>

<script>

import customerForm from '@/components/customerForm'

export default {
  async fetch({ store, error }) {
    await Promise.all(
      [
        store.dispatch('testnoova/api/customer/fetchCustomers') 
      ].map(p => p.catch(e => {
        error({ statusCode: e.response.status, message: 'Ha ocurrido un error' })
      })))
  },
  components: {
    customerForm
  },
  data() {
    return {
      // -------------------------------------------------------
      // general
      // -------------------------------------------------------      
      loading: false,
      dialogCustomer: false,
      pageSize: this.$store.getters['testnoova/pageSize'],
      // -------------------------------------------------------
      // =======================================================
      // -------------------------------------------------------
      // filter data
      // -------------------------------------------------------
      filter: '',
      timeout: null,
      // -------------------------------------------------------
      selectedCustomer: null
      // -------------------------------------------------------
    }
  },
  computed: {
    customers() { return this.$store.getters['testnoova/api/customer/customers'] }
  },
  watch: {
    filter() {
      // bouncing
      clearTimeout(this.timeout)
      this.timeout = setTimeout(async _ => {
        await this.fetchCustomers()
      }, 500)
    }
  },
  methods: {
    onEditCustomer(customer) {
      this.dialogCustomer = true
      this.selectedCustomer = Object.assign({}, customer)
    },
    editCustomer(customer) {
      this.$store
      .dispatch("testnoova/api/customer/updateCustomer", customer)
      .then((res) => {
        console.log(res);
        this.dialogCustomer = false
        this.$message({
          message: `Cliente ${customer.fullName} editado`,
          type: "success"
        });
      })
      .catch(error => {
        if(error.response.status != 200) {
          this.$message.error(`ha ocurrido un error editando el cliente: ${error.response.status}`);
        }
      });
    },
    deleteCustomer(customer) {
      console.log(customer)
      this.$store
      .dispatch("testnoova/api/customer/deleteCustomer", customer.id)
      .then((res) => {
        console.log(res);
        this.$message({
          message: `Cliente ${customer.fullName} eliminado`,
          type: "success"
        });
      })
      .catch(error => {
        if(error.response.status != 200) {
          this.$message.error(`ha ocurrido un error eliminando el cliente: ${error.response.status}`);
        }
      });
    },
    async fetchCustomers() {
      this.loading = true
      await this.$store.dispatch('testnoova/api/customer/fetchCustomers', 
        this.filter
      ).catch(e => {
        this.$nuxt.error({ statusCode: e.response.status, message: "Ha ocurrido un error" })
      })
      this.loading = false
    }
  }
}
</script>

<style>
</style>